Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -2946,6 +8956,1201 @@
         private static void clearrequestfields(minlbfgsstate state)
         {
+            state.needf = false;
             state.needfg = false;
             state.xupdated = false;
+        }
+
+
+    }
+    public class minqp
+    {
+        /*************************************************************************
+        This object stores nonlinear optimizer state.
+        You should use functions provided by MinQP subpackage to work with this
+        object
+        *************************************************************************/
+        public class minqpstate
+        {
+            public int n;
+            public int algokind;
+            public int akind;
+            public double[,] densea;
+            public double[] diaga;
+            public double[] b;
+            public double[] bndl;
+            public double[] bndu;
+            public bool[] havebndl;
+            public bool[] havebndu;
+            public double[] xorigin;
+            public double[] startx;
+            public bool havex;
+            public double[] xc;
+            public double[] gc;
+            public int[] activeconstraints;
+            public int[] prevactiveconstraints;
+            public double constterm;
+            public double[] workbndl;
+            public double[] workbndu;
+            public int repinneriterationscount;
+            public int repouteriterationscount;
+            public int repncholesky;
+            public int repnmv;
+            public int repterminationtype;
+            public double[] tmp0;
+            public double[] tmp1;
+            public int[] itmp0;
+            public int[] p2;
+            public double[,] bufa;
+            public double[] bufb;
+            public double[] bufx;
+            public apserv.apbuffers buf;
+            public minqpstate()
+            {
+                densea = new double[0,0];
+                diaga = new double[0];
+                b = new double[0];
+                bndl = new double[0];
+                bndu = new double[0];
+                havebndl = new bool[0];
+                havebndu = new bool[0];
+                xorigin = new double[0];
+                startx = new double[0];
+                xc = new double[0];
+                gc = new double[0];
+                activeconstraints = new int[0];
+                prevactiveconstraints = new int[0];
+                workbndl = new double[0];
+                workbndu = new double[0];
+                tmp0 = new double[0];
+                tmp1 = new double[0];
+                itmp0 = new int[0];
+                p2 = new int[0];
+                bufa = new double[0,0];
+                bufb = new double[0];
+                bufx = new double[0];
+                buf = new apserv.apbuffers();
+            }
+        };
+
+
+        /*************************************************************************
+        This structure stores optimization report:
+        * InnerIterationsCount      number of inner iterations
+        * OuterIterationsCount      number of outer iterations
+        * NCholesky                 number of Cholesky decomposition
+        * NMV                       number of matrix-vector products
+                                    (only products calculated as part of iterative
+                                    process are counted)
+        * TerminationType           completion code (see below)
+
+        Completion codes:
+        * -5    inappropriate solver was used:
+                * Cholesky solver for semidefinite or indefinite problems
+                * Cholesky solver for problems with non-boundary constraints
+        * -3    inconsistent constraints (or, maybe, feasible point is
+                too hard to find). If you are sure that constraints are feasible,
+                try to restart optimizer with better initial approximation.
+        *  4    successful completion
+        *  5    MaxIts steps was taken
+        *  7    stopping conditions are too stringent,
+                further improvement is impossible,
+                X contains best point found so far.
+        *************************************************************************/
+        public class minqpreport
+        {
+            public int inneriterationscount;
+            public int outeriterationscount;
+            public int nmv;
+            public int ncholesky;
+            public int terminationtype;
+        };
+
+
+
+
+        /*************************************************************************
+                            CONSTRAINED QUADRATIC PROGRAMMING
+
+        The subroutine creates QP optimizer. After initial creation,  it  contains
+        default optimization problem with zero quadratic and linear terms  and  no
+        constraints. You should set quadratic/linear terms with calls to functions
+        provided by MinQP subpackage.
+
+        INPUT PARAMETERS:
+            N       -   problem size
+            
+        OUTPUT PARAMETERS:
+            State   -   optimizer with zero quadratic/linear terms
+                        and no constraints
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpcreate(int n,
+            minqpstate state)
+        {
+            int i = 0;
+
+            ap.assert(n>=1, "MinQPCreate: N<1");
+            
+            //
+            // initialize QP solver
+            //
+            state.n = n;
+            state.akind = -1;
+            state.repterminationtype = 0;
+            state.b = new double[n];
+            state.bndl = new double[n];
+            state.bndu = new double[n];
+            state.workbndl = new double[n];
+            state.workbndu = new double[n];
+            state.havebndl = new bool[n];
+            state.havebndu = new bool[n];
+            state.startx = new double[n];
+            state.xorigin = new double[n];
+            state.xc = new double[n];
+            state.gc = new double[n];
+            for(i=0; i<=n-1; i++)
+            {
+                state.b[i] = 0.0;
+                state.workbndl[i] = Double.NegativeInfinity;
+                state.workbndu[i] = Double.PositiveInfinity;
+                state.havebndl[i] = false;
+                state.havebndu[i] = false;
+                state.startx[i] = 0.0;
+                state.xorigin[i] = 0.0;
+            }
+            state.havex = false;
+            minqpsetalgocholesky(state);
+        }
+
+
+        /*************************************************************************
+        This function sets linear term for QP solver.
+
+        By default, linear term is zero.
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+            B       -   linear term, array[N].
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetlinearterm(minqpstate state,
+            double[] b)
+        {
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.len(b)>=n, "MinQPSetLinearTerm: Length(B)<N");
+            ap.assert(apserv.isfinitevector(b, n), "MinQPSetLinearTerm: B contains infinite or NaN elements");
+            minqpsetlineartermfast(state, b);
+        }
+
+
+        /*************************************************************************
+        This function sets quadratic term for QP solver.
+
+        By default quadratic term is zero.
+
+        IMPORTANT: this solver minimizes following  function:
+            f(x) = 0.5*x'*A*x + b'*x.
+        Note that quadratic term has 0.5 before it. So if  you  want  to  minimize
+            f(x) = x^2 + x
+        you should rewrite your problem as follows:
+            f(x) = 0.5*(2*x^2) + x
+        and your matrix A will be equal to [[2.0]], not to [[1.0]]
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+            A       -   matrix, array[N,N]
+            IsUpper -   (optional) storage type:
+                        * if True, symmetric matrix  A  is  given  by  its  upper
+                          triangle, and the lower triangle isnt used
+                        * if False, symmetric matrix  A  is  given  by  its lower
+                          triangle, and the upper triangle isnt used
+                        * if not given, both lower and upper  triangles  must  be
+                          filled.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetquadraticterm(minqpstate state,
+            double[,] a,
+            bool isupper)
+        {
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.rows(a)>=n, "MinQPSetQuadraticTerm: Rows(A)<N");
+            ap.assert(ap.cols(a)>=n, "MinQPSetQuadraticTerm: Cols(A)<N");
+            ap.assert(apserv.isfinitertrmatrix(a, n, isupper), "MinQPSetQuadraticTerm: A contains infinite or NaN elements");
+            minqpsetquadratictermfast(state, a, isupper, 0.0);
+        }
+
+
+        /*************************************************************************
+        This function sets starting point for QP solver. It is useful to have
+        good initial approximation to the solution, because it will increase
+        speed of convergence and identification of active constraints.
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+            X       -   starting point, array[N].
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetstartingpoint(minqpstate state,
+            double[] x)
+        {
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.len(x)>=n, "MinQPSetStartingPoint: Length(B)<N");
+            ap.assert(apserv.isfinitevector(x, n), "MinQPSetStartingPoint: X contains infinite or NaN elements");
+            minqpsetstartingpointfast(state, x);
+        }
+
+
+        /*************************************************************************
+        This  function sets origin for QP solver. By default, following QP program
+        is solved:
+
+            min(0.5*x'*A*x+b'*x)
+            
+        This function allows to solve different problem:
+
+            min(0.5*(x-x_origin)'*A*(x-x_origin)+b'*(x-x_origin))
+            
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+            XOrigin -   origin, array[N].
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetorigin(minqpstate state,
+            double[] xorigin)
+        {
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.len(xorigin)>=n, "MinQPSetOrigin: Length(B)<N");
+            ap.assert(apserv.isfinitevector(xorigin, n), "MinQPSetOrigin: B contains infinite or NaN elements");
+            minqpsetoriginfast(state, xorigin);
+        }
+
+
+        /*************************************************************************
+        This function tells solver to use Cholesky-based algorithm.
+
+        Cholesky-based algorithm can be used when:
+        * problem is convex
+        * there is no constraints or only boundary constraints are present
+
+        This algorithm has O(N^3) complexity for unconstrained problem and  is  up
+        to several times slower on bound constrained  problems  (these  additional
+        iterations are needed to identify active constraints).
+
+        INPUT PARAMETERS:
+            State   -   structure which stores algorithm state
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetalgocholesky(minqpstate state)
+        {
+            state.algokind = 1;
+        }
+
+
+        /*************************************************************************
+        This function sets boundary constraints for QP solver
+
+        Boundary constraints are inactive by default (after initial creation).
+        After  being  set,  they  are  preserved  until explicitly turned off with
+        another SetBC() call.
+
+        INPUT PARAMETERS:
+            State   -   structure stores algorithm state
+            BndL    -   lower bounds, array[N].
+                        If some (all) variables are unbounded, you may specify
+                        very small number or -INF (latter is recommended because
+                        it will allow solver to use better algorithm).
+            BndU    -   upper bounds, array[N].
+                        If some (all) variables are unbounded, you may specify
+                        very large number or +INF (latter is recommended because
+                        it will allow solver to use better algorithm).
+                        
+        NOTE: it is possible to specify BndL[i]=BndU[i]. In this case I-th
+        variable will be "frozen" at X[i]=BndL[i]=BndU[i].
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetbc(minqpstate state,
+            double[] bndl,
+            double[] bndu)
+        {
+            int i = 0;
+            int n = 0;
+
+            n = state.n;
+            ap.assert(ap.len(bndl)>=n, "MinQPSetBC: Length(BndL)<N");
+            ap.assert(ap.len(bndu)>=n, "MinQPSetBC: Length(BndU)<N");
+            for(i=0; i<=n-1; i++)
+            {
+                ap.assert(math.isfinite(bndl[i]) | Double.IsNegativeInfinity(bndl[i]), "MinQPSetBC: BndL contains NAN or +INF");
+                ap.assert(math.isfinite(bndu[i]) | Double.IsPositiveInfinity(bndu[i]), "MinQPSetBC: BndU contains NAN or -INF");
+                state.bndl[i] = bndl[i];
+                state.havebndl[i] = math.isfinite(bndl[i]);
+                state.bndu[i] = bndu[i];
+                state.havebndu[i] = math.isfinite(bndu[i]);
+            }
+        }
+
+
+        /*************************************************************************
+        This function solves quadratic programming problem.
+        You should call it after setting solver options with MinQPSet...() calls.
+
+        INPUT PARAMETERS:
+            State   -   algorithm state
+
+        You should use MinQPResults() function to access results after calls
+        to this function.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpoptimize(minqpstate state)
+        {
+            int n = 0;
+            int i = 0;
+            int j = 0;
+            int k = 0;
+            int nbc = 0;
+            int nlc = 0;
+            int nactive = 0;
+            int nfree = 0;
+            double f = 0;
+            double fprev = 0;
+            double v = 0;
+            bool b = new bool();
+            int i_ = 0;
+
+            n = state.n;
+            state.repterminationtype = -5;
+            state.repinneriterationscount = 0;
+            state.repouteriterationscount = 0;
+            state.repncholesky = 0;
+            state.repnmv = 0;
+            
+            //
+            // check correctness of constraints
+            //
+            for(i=0; i<=n-1; i++)
+            {
+                if( state.havebndl[i] & state.havebndu[i] )
+                {
+                    if( (double)(state.bndl[i])>(double)(state.bndu[i]) )
+                    {
+                        state.repterminationtype = -3;
+                        return;
+                    }
+                }
+            }
+            
+            //
+            // count number of bound and linear constraints
+            //
+            nbc = 0;
+            nlc = 0;
+            for(i=0; i<=n-1; i++)
+            {
+                if( state.havebndl[i] )
+                {
+                    nbc = nbc+1;
+                }
+                if( state.havebndu[i] )
+                {
+                    nbc = nbc+1;
+                }
+            }
+            
+            //
+            // Our formulation of quadratic problem includes origin point,
+            // i.e. we have F(x-x_origin) which is minimized subject to
+            // constraints on x, instead of having simply F(x).
+            //
+            // Here we make transition from non-zero origin to zero one.
+            // In order to make such transition we have to:
+            // 1. subtract x_origin from x_start
+            // 2. modify constraints
+            // 3. solve problem
+            // 4. add x_origin to solution
+            //
+            // There is alternate solution - to modify quadratic function
+            // by expansion of multipliers containing (x-x_origin), but
+            // we prefer to modify constraints, because it is a) more precise
+            // and b) easier to to.
+            //
+            // Parts (1)-(2) are done here. After this block is over,
+            // we have:
+            // * XC, which stores shifted XStart (if we don't have XStart,
+            //   value of XC will be ignored later)
+            // * WorkBndL, WorkBndU, which store modified boundary constraints.
+            //
+            for(i=0; i<=n-1; i++)
+            {
+                state.xc[i] = state.startx[i]-state.xorigin[i];
+                if( state.havebndl[i] )
+                {
+                    state.workbndl[i] = state.bndl[i]-state.xorigin[i];
+                }
+                if( state.havebndu[i] )
+                {
+                    state.workbndu[i] = state.bndu[i]-state.xorigin[i];
+                }
+            }
+            
+            //
+            // modify starting point XC according to boundary constraints
+            //
+            if( state.havex )
+            {
+                
+                //
+                // We have starting point in XC, so we just have to bound it
+                //
+                for(i=0; i<=n-1; i++)
+                {
+                    if( state.havebndl[i] )
+                    {
+                        if( (double)(state.xc[i])<(double)(state.workbndl[i]) )
+                        {
+                            state.xc[i] = state.workbndl[i];
+                        }
+                    }
+                    if( state.havebndu[i] )
+                    {
+                        if( (double)(state.xc[i])>(double)(state.workbndu[i]) )
+                        {
+                            state.xc[i] = state.workbndu[i];
+                        }
+                    }
+                }
+            }
+            else
+            {
+                
+                //
+                // We don't have starting point, so we deduce it from
+                // constraints (if they are present).
+                //
+                // NOTE: XC contains some meaningless values from previous block
+                // which are ignored by code below.
+                //
+                for(i=0; i<=n-1; i++)
+                {
+                    if( state.havebndl[i] & state.havebndu[i] )
+                    {
+                        state.xc[i] = 0.5*(state.workbndl[i]+state.workbndu[i]);
+                        if( (double)(state.xc[i])<(double)(state.workbndl[i]) )
+                        {
+                            state.xc[i] = state.workbndl[i];
+                        }
+                        if( (double)(state.xc[i])>(double)(state.workbndu[i]) )
+                        {
+                            state.xc[i] = state.workbndu[i];
+                        }
+                        continue;
+                    }
+                    if( state.havebndl[i] )
+                    {
+                        state.xc[i] = state.workbndl[i];
+                        continue;
+                    }
+                    if( state.havebndu[i] )
+                    {
+                        state.xc[i] = state.workbndu[i];
+                        continue;
+                    }
+                    state.xc[i] = 0;
+                }
+            }
+            
+            //
+            // Select algo
+            //
+            if( state.algokind==1 & state.akind==0 )
+            {
+                
+                //
+                // Cholesky-based algorithm for dense bound constrained problems.
+                //
+                // This algorithm exists in two variants:
+                // * unconstrained one, which can solve problem using only one NxN
+                //   double matrix
+                // * bound constrained one, which needs two NxN matrices
+                //
+                // We will try to solve problem using unconstrained algorithm,
+                // and will use bound constrained version only when constraints
+                // are actually present
+                //
+                if( nbc==0 & nlc==0 )
+                {
+                    
+                    //
+                    // "Simple" unconstrained version
+                    //
+                    apserv.rvectorsetlengthatleast(ref state.tmp0, n);
+                    apserv.rvectorsetlengthatleast(ref state.bufb, n);
+                    state.densea[0,0] = state.diaga[0];
+                    for(k=1; k<=n-1; k++)
+                    {
+                        for(i_=0; i_<=k-1;i_++)
+                        {
+                            state.densea[i_,k] = state.densea[k,i_];
+                        }
+                        state.densea[k,k] = state.diaga[k];
+                    }
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.bufb[i_] = state.b[i_];
+                    }
+                    state.repncholesky = 1;
+                    if( !trfac.spdmatrixcholeskyrec(ref state.densea, 0, n, true, ref state.tmp0) )
+                    {
+                        state.repterminationtype = -5;
+                        return;
+                    }
+                    fbls.fblscholeskysolve(state.densea, 1.0, n, true, ref state.bufb, ref state.tmp0);
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.xc[i_] = -state.bufb[i_];
+                    }
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.xc[i_] = state.xc[i_] + state.xorigin[i_];
+                    }
+                    state.repouteriterationscount = 1;
+                    state.repterminationtype = 4;
+                    return;
+                }
+                
+                //
+                // General bound constrained algo
+                //
+                apserv.rmatrixsetlengthatleast(ref state.bufa, n, n);
+                apserv.rvectorsetlengthatleast(ref state.bufb, n);
+                apserv.rvectorsetlengthatleast(ref state.bufx, n);
+                apserv.ivectorsetlengthatleast(ref state.activeconstraints, n);
+                apserv.ivectorsetlengthatleast(ref state.prevactiveconstraints, n);
+                apserv.rvectorsetlengthatleast(ref state.tmp0, n);
+                
+                //
+                // Prepare constraints vectors:
+                // * ActiveConstraints - constraints active at current step
+                // * PrevActiveConstraints - constraints which were active at previous step
+                //
+                // Elements of constraints vectors can be:
+                // *  0 - inactive
+                // *  1 - active
+                // * -1 - undefined (used to initialize PrevActiveConstraints before first iteration)
+                //
+                for(i=0; i<=n-1; i++)
+                {
+                    state.prevactiveconstraints[i] = -1;
+                }
+                
+                //
+                // Main cycle
+                //
+                fprev = math.maxrealnumber;
+                while( true )
+                {
+                    
+                    //
+                    // * calculate gradient at XC
+                    // * determine active constraints
+                    // * break if there is no free variables or
+                    //   there were no changes in the list of active constraints
+                    //
+                    minqpgrad(state);
+                    nactive = 0;
+                    for(i=0; i<=n-1; i++)
+                    {
+                        state.activeconstraints[i] = 0;
+                        if( state.havebndl[i] )
+                        {
+                            if( (double)(state.xc[i])<=(double)(state.workbndl[i]) & (double)(state.gc[i])>=(double)(0) )
+                            {
+                                state.activeconstraints[i] = 1;
+                            }
+                        }
+                        if( state.havebndu[i] )
+                        {
+                            if( (double)(state.xc[i])>=(double)(state.workbndu[i]) & (double)(state.gc[i])<=(double)(0) )
+                            {
+                                state.activeconstraints[i] = 1;
+                            }
+                        }
+                        if( state.havebndl[i] & state.havebndu[i] )
+                        {
+                            if( (double)(state.workbndl[i])==(double)(state.workbndu[i]) )
+                            {
+                                state.activeconstraints[i] = 1;
+                            }
+                        }
+                        if( state.activeconstraints[i]>0 )
+                        {
+                            nactive = nactive+1;
+                        }
+                    }
+                    nfree = n-nactive;
+                    if( nfree==0 )
+                    {
+                        break;
+                    }
+                    b = false;
+                    for(i=0; i<=n-1; i++)
+                    {
+                        if( state.activeconstraints[i]!=state.prevactiveconstraints[i] )
+                        {
+                            b = true;
+                        }
+                    }
+                    if( !b )
+                    {
+                        break;
+                    }
+                    
+                    //
+                    // * copy A, B and X to buffer
+                    // * rearrange BufA, BufB and BufX, in such way that active variables come first,
+                    //   inactive are moved to the tail. We use sorting subroutine
+                    //   to solve this problem.
+                    //
+                    state.bufa[0,0] = state.diaga[0];
+                    for(k=1; k<=n-1; k++)
+                    {
+                        for(i_=0; i_<=k-1;i_++)
+                        {
+                            state.bufa[k,i_] = state.densea[k,i_];
+                        }
+                        for(i_=0; i_<=k-1;i_++)
+                        {
+                            state.bufa[i_,k] = state.densea[k,i_];
+                        }
+                        state.bufa[k,k] = state.diaga[k];
+                    }
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.bufb[i_] = state.b[i_];
+                    }
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.bufx[i_] = state.xc[i_];
+                    }
+                    for(i=0; i<=n-1; i++)
+                    {
+                        state.tmp0[i] = state.activeconstraints[i];
+                    }
+                    tsort.tagsortbuf(ref state.tmp0, n, ref state.itmp0, ref state.p2, state.buf);
+                    for(k=0; k<=n-1; k++)
+                    {
+                        if( state.p2[k]!=k )
+                        {
+                            v = state.bufb[k];
+                            state.bufb[k] = state.bufb[state.p2[k]];
+                            state.bufb[state.p2[k]] = v;
+                            v = state.bufx[k];
+                            state.bufx[k] = state.bufx[state.p2[k]];
+                            state.bufx[state.p2[k]] = v;
+                        }
+                    }
+                    for(i=0; i<=n-1; i++)
+                    {
+                        for(i_=0; i_<=n-1;i_++)
+                        {
+                            state.tmp0[i_] = state.bufa[i,i_];
+                        }
+                        for(k=0; k<=n-1; k++)
+                        {
+                            if( state.p2[k]!=k )
+                            {
+                                v = state.tmp0[k];
+                                state.tmp0[k] = state.tmp0[state.p2[k]];
+                                state.tmp0[state.p2[k]] = v;
+                            }
+                        }
+                        for(i_=0; i_<=n-1;i_++)
+                        {
+                            state.bufa[i,i_] = state.tmp0[i_];
+                        }
+                    }
+                    for(i=0; i<=n-1; i++)
+                    {
+                        if( state.p2[i]!=i )
+                        {
+                            for(i_=0; i_<=n-1;i_++)
+                            {
+                                state.tmp0[i_] = state.bufa[i,i_];
+                            }
+                            for(i_=0; i_<=n-1;i_++)
+                            {
+                                state.bufa[i,i_] = state.bufa[state.p2[i],i_];
+                            }
+                            for(i_=0; i_<=n-1;i_++)
+                            {
+                                state.bufa[state.p2[i],i_] = state.tmp0[i_];
+                            }
+                        }
+                    }
+                    
+                    //
+                    // Now we have A and B in BufA and BufB, variables are rearranged
+                    // into two groups: Xf - free variables, Xc - active (fixed) variables,
+                    // and our quadratic problem can be written as
+                    //
+                    //                           ( Af  Ac  )   ( Xf )                 ( Xf )
+                    // F(X) = 0.5* ( Xf' Xc' ) * (         ) * (    ) + ( Bf' Bc' ) * (    )
+                    //                           ( Ac' Acc )   ( Xc )                 ( Xc )
+                    //
+                    // we want to convert to the optimization with respect to Xf,
+                    // treating Xc as constant term. After expansion of expression above
+                    // we get
+                    //
+                    // F(Xf) = 0.5*Xf'*Af*Xf + (Bf+Ac*Xc)'*Xf + 0.5*Xc'*Acc*Xc
+                    //
+                    // We will update BufB using this expression and calculate
+                    // constant term.
+                    //
+                    ablas.rmatrixmv(nfree, nactive, state.bufa, 0, nfree, 0, state.bufx, nfree, ref state.tmp0, 0);
+                    for(i_=0; i_<=nfree-1;i_++)
+                    {
+                        state.bufb[i_] = state.bufb[i_] + state.tmp0[i_];
+                    }
+                    state.constterm = 0.0;
+                    for(i=nfree; i<=n-1; i++)
+                    {
+                        state.constterm = state.constterm+0.5*state.bufx[i]*state.bufa[i,i]*state.bufx[i];
+                        for(j=i+1; j<=n-1; j++)
+                        {
+                            state.constterm = state.constterm+state.bufx[i]*state.bufa[i,j]*state.bufx[j];
+                        }
+                    }
+                    
+                    //
+                    // Now we are ready to minimize F(Xf)...
+                    //
+                    state.repncholesky = state.repncholesky+1;
+                    if( !trfac.spdmatrixcholeskyrec(ref state.bufa, 0, nfree, true, ref state.tmp0) )
+                    {
+                        state.repterminationtype = -5;
+                        return;
+                    }
+                    fbls.fblscholeskysolve(state.bufa, 1.0, nfree, true, ref state.bufb, ref state.tmp0);
+                    for(i_=0; i_<=nfree-1;i_++)
+                    {
+                        state.bufx[i_] = -state.bufb[i_];
+                    }
+                    
+                    //
+                    // ...and to copy results back to XC.
+                    //
+                    // It is done in several steps:
+                    // * original order of variables is restored
+                    // * result is copied back to XC
+                    // * XC is bounded with respect to bound constraints
+                    //
+                    for(k=n-1; k>=0; k--)
+                    {
+                        if( state.p2[k]!=k )
+                        {
+                            v = state.bufx[k];
+                            state.bufx[k] = state.bufx[state.p2[k]];
+                            state.bufx[state.p2[k]] = v;
+                        }
+                    }
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        state.xc[i_] = state.bufx[i_];
+                    }
+                    for(i=0; i<=n-1; i++)
+                    {
+                        if( state.havebndl[i] )
+                        {
+                            if( (double)(state.xc[i])<(double)(state.workbndl[i]) )
+                            {
+                                state.xc[i] = state.workbndl[i];
+                            }
+                        }
+                        if( state.havebndu[i] )
+                        {
+                            if( (double)(state.xc[i])>(double)(state.workbndu[i]) )
+                            {
+                                state.xc[i] = state.workbndu[i];
+                            }
+                        }
+                    }
+                    
+                    //
+                    // Calculate F, compare it with FPrev.
+                    //
+                    // Break if F>=FPrev
+                    // (sometimes possible at extremum due to numerical noise).
+                    //
+                    f = 0.0;
+                    for(i_=0; i_<=n-1;i_++)
+                    {
+                        f += state.b[i_]*state.xc[i_];
+                    }
+                    f = f+minqpxtax(state, state.xc);
+                    if( (double)(f)>=(double)(fprev) )
+                    {
+                        break;
+                    }
+                    fprev = f;
+                    
+                    //
+                    // Update PrevActiveConstraints
+                    //
+                    for(i=0; i<=n-1; i++)
+                    {
+                        state.prevactiveconstraints[i] = state.activeconstraints[i];
+                    }
+                    
+                    //
+                    // Update report-related fields
+                    //
+                    state.repouteriterationscount = state.repouteriterationscount+1;
+                }
+                state.repterminationtype = 4;
+                for(i_=0; i_<=n-1;i_++)
+                {
+                    state.xc[i_] = state.xc[i_] + state.xorigin[i_];
+                }
+                return;
+            }
+        }
+
+
+        /*************************************************************************
+        QP solver results
+
+        INPUT PARAMETERS:
+            State   -   algorithm state
+
+        OUTPUT PARAMETERS:
+            X       -   array[0..N-1], solution
+            Rep     -   optimization report. You should check Rep.TerminationType,
+                        which contains completion code, and you may check  another
+                        fields which contain another information  about  algorithm
+                        functioning.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpresults(minqpstate state,
+            ref double[] x,
+            minqpreport rep)
+        {
+            x = new double[0];
+
+            minqpresultsbuf(state, ref x, rep);
+        }
+
+
+        /*************************************************************************
+        QP results
+
+        Buffered implementation of MinQPResults() which uses pre-allocated  buffer
+        to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
+        intended to be used in the inner cycles of performance critical algorithms
+        where array reallocation penalty is too large to be ignored.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpresultsbuf(minqpstate state,
+            ref double[] x,
+            minqpreport rep)
+        {
+            int i_ = 0;
+
+            if( ap.len(x)<state.n )
+            {
+                x = new double[state.n];
+            }
+            for(i_=0; i_<=state.n-1;i_++)
+            {
+                x[i_] = state.xc[i_];
+            }
+            rep.inneriterationscount = state.repinneriterationscount;
+            rep.outeriterationscount = state.repouteriterationscount;
+            rep.nmv = state.repnmv;
+            rep.terminationtype = state.repterminationtype;
+        }
+
+
+        /*************************************************************************
+        Fast version of MinQPSetLinearTerm(), which doesn't check its arguments.
+        For internal use only.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetlineartermfast(minqpstate state,
+            double[] b)
+        {
+            int n = 0;
+            int i_ = 0;
+
+            n = state.n;
+            for(i_=0; i_<=n-1;i_++)
+            {
+                state.b[i_] = b[i_];
+            }
+        }
+
+
+        /*************************************************************************
+        Fast version of MinQPSetQuadraticTerm(), which doesn't check its arguments.
+
+        It accepts additional parameter - shift S, which allows to "shift"  matrix
+        A by adding s*I to A. S must be positive (although it is not checked).
+
+        For internal use only.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetquadratictermfast(minqpstate state,
+            double[,] a,
+            bool isupper,
+            double s)
+        {
+            int k = 0;
+            int n = 0;
+            int i_ = 0;
+
+            
+            //
+            // We store off-diagonal part of A in the lower triangle of DenseA.
+            // Diagonal elements of A are stored in the DiagA.
+            // Diagonal of DenseA and uppper triangle are used as temporaries.
+            //
+            // Why such complex storage? Because it:
+            // 1. allows us to easily recover from exceptions (lower triangle
+            //    is unmodified during execution as well as DiagA, and on entry
+            //    we will always find unmodified matrix)
+            // 2. allows us to make Cholesky decomposition in the upper triangle
+            //    of DenseA or to do other SPD-related operations.
+            //
+            n = state.n;
+            state.akind = 0;
+            apserv.rmatrixsetlengthatleast(ref state.densea, n, n);
+            apserv.rvectorsetlengthatleast(ref state.diaga, n);
+            if( isupper )
+            {
+                for(k=0; k<=n-2; k++)
+                {
+                    state.diaga[k] = a[k,k]+s;
+                    for(i_=k+1; i_<=n-1;i_++)
+                    {
+                        state.densea[i_,k] = a[k,i_];
+                    }
+                }
+                state.diaga[n-1] = a[n-1,n-1]+s;
+            }
+            else
+            {
+                state.diaga[0] = a[0,0]+s;
+                for(k=1; k<=n-1; k++)
+                {
+                    for(i_=0; i_<=k-1;i_++)
+                    {
+                        state.densea[k,i_] = a[k,i_];
+                    }
+                    state.diaga[k] = a[k,k]+s;
+                }
+            }
+        }
+
+
+        /*************************************************************************
+        Interna lfunction which allows to rewrite diagonal of quadratic term.
+        For internal use only.
+
+        This function can be used only when you have dense A and already made
+        MinQPSetQuadraticTerm(Fast) call.
+
+          -- ALGLIB --
+             Copyright 16.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqprewritediagonal(minqpstate state,
+            double[] s)
+        {
+            int k = 0;
+            int n = 0;
+
+            ap.assert(state.akind==0, "MinQPRewriteDiagonal: internal error (AKind<>0)");
+            n = state.n;
+            for(k=0; k<=n-1; k++)
+            {
+                state.diaga[k] = s[k];
+            }
+        }
+
+
+        /*************************************************************************
+        Fast version of MinQPSetStartingPoint(), which doesn't check its arguments.
+        For internal use only.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetstartingpointfast(minqpstate state,
+            double[] x)
+        {
+            int n = 0;
+            int i_ = 0;
+
+            n = state.n;
+            for(i_=0; i_<=n-1;i_++)
+            {
+                state.startx[i_] = x[i_];
+            }
+            state.havex = true;
+        }
+
+
+        /*************************************************************************
+        Fast version of MinQPSetOrigin(), which doesn't check its arguments.
+        For internal use only.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void minqpsetoriginfast(minqpstate state,
+            double[] xorigin)
+        {
+            int n = 0;
+            int i_ = 0;
+
+            n = state.n;
+            for(i_=0; i_<=n-1;i_++)
+            {
+                state.xorigin[i_] = xorigin[i_];
+            }
+        }
+
+
+        /*************************************************************************
+        This  function  calculates gradient of quadratic function at XC and stores
+        it in the GC.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        private static void minqpgrad(minqpstate state)
+        {
+            int n = 0;
+            int i = 0;
+            double v = 0;
+            int i_ = 0;
+
+            n = state.n;
+            ap.assert(state.akind==-1 | state.akind==0, "MinQPGrad: internal error");
+            
+            //
+            // zero A
+            //
+            if( state.akind==-1 )
+            {
+                for(i_=0; i_<=n-1;i_++)
+                {
+                    state.gc[i_] = state.b[i_];
+                }
+                return;
+            }
+            
+            //
+            // dense A
+            //
+            if( state.akind==0 )
+            {
+                for(i_=0; i_<=n-1;i_++)
+                {
+                    state.gc[i_] = state.b[i_];
+                }
+                state.gc[0] = state.gc[0]+state.diaga[0]*state.xc[0];
+                for(i=1; i<=n-1; i++)
+                {
+                    v = 0.0;
+                    for(i_=0; i_<=i-1;i_++)
+                    {
+                        v += state.densea[i,i_]*state.xc[i_];
+                    }
+                    state.gc[i] = state.gc[i]+v+state.diaga[i]*state.xc[i];
+                    v = state.xc[i];
+                    for(i_=0; i_<=i-1;i_++)
+                    {
+                        state.gc[i_] = state.gc[i_] + v*state.densea[i,i_];
+                    }
+                }
+                return;
+            }
+        }
+
+
+        /*************************************************************************
+        This  function  calculates x'*A*x for given X.
+
+          -- ALGLIB --
+             Copyright 11.01.2011 by Bochkanov Sergey
+        *************************************************************************/
+        private static double minqpxtax(minqpstate state,
+            double[] x)
+        {
+            double result = 0;
+            int n = 0;
+            int i = 0;
+            int j = 0;
+
+            n = state.n;
+            ap.assert(state.akind==-1 | state.akind==0, "MinQPXTAX: internal error");
+            result = 0;
+            
+            //
+            // zero A
+            //
+            if( state.akind==-1 )
+            {
+                result = 0.0;
+                return result;
+            }
+            
+            //
+            // dense A
+            //
+            if( state.akind==0 )
+            {
+                result = 0;
+                for(i=0; i<=n-1; i++)
+                {
+                    for(j=0; j<=i-1; j++)
+                    {
+                        result = result+state.densea[i,j]*x[i]*x[j];
+                    }
+                    result = result+0.5*state.diaga[i]*math.sqr(x[i]);
+                }
+                return result;
+            }
+            return result;
         }
 
